// ============================================================================
// $Id: log.cc,v 1.1 1996/04/22 18:25:24 questor Exp $
//
// This is part of Realm Of Magic
//
// Usage: Class that handles the logging of the intermud server
//
// All rights reserved. See license.doc for complete information.
//
// Copyright (C) 1993-1996 by the Hackerz of the Realm Of Magic
// Realm Of Magic is based on CircleMUD, Copyright (C) 1993.
// CircleMUD is based on DikuMUD, Copyright (C) 1990, 1991.
// Original intermud_client.c (C) 1995, 96 by Chris Austin (Stryker@Tempus)
// Original lpc protocol (C) by Mark Lewis (Nostradamus@Zebedee)
//                           by J.W. Armstrong (Alvin@Suhi)
// ============================================================================

#include <string>
#include <stdio.h>
#include <iostream.h>
#include <iomanip.h>
#include <sys/time.h>

#include "log.hh"

_log& _log::operator<<(string s)
{
  this->data += s;
  return *this;
}

_log& _log::operator<<(int i)
{
  char num_buf[256];
  sprintf(num_buf, "%d", i);
  this->data += num_buf;
  return *this;
}

_log& _log::operator<<(unsigned int ui)
{
  char num_buf[256];
  sprintf(num_buf, "%u", ui);
  this->data += num_buf;
  return *this;
}

_log& _log::operator<<(long int li)
{
  char num_buf[256];
  sprintf(num_buf, "%ld", li);
  this->data += num_buf;
  return *this;
}

_log& _log::operator<<(unsigned long int uli)
{
  char num_buf[256];
  sprintf(num_buf, "%lu", uli);
  this->data += num_buf;
  return *this;
}

_log& _log::operator<<(short int si)
{
  return (*this) << (int)si;
}

_log& _log::operator<<(unsigned short int usi)
{
  return (*this) << (unsigned int)usi;
}

_log& _log::operator<<(_log& (*pf)(_log&))
{
  return (*pf)(*this);
}

_log& logit(_log& flush_log)
{
  long int ct;
  string timestamp;
  
  ct = time(0);
  timestamp = asctime(localtime(&ct));
  timestamp.erase(timestamp.size() - 1);

  cerr.setf(ios::left);
  cerr << timestamp << " ::{46} " << flush_log.data << endl;
  flush_log.data = "";
  return flush_log;
}

