// ============================================================================
// $Id: net.hh,v 1.2 1996/04/26 23:33:04 questor Exp $
//
// This is part of Realm Of Magic
//
// Usage: Class that cares for the intermud <-> net communication
//
// All rights reserved. See license.doc for complete information.
//
// Copyright (C) 1993-1996 by the Hackerz of the Realm Of Magic
// Realm Of Magic is based on CircleMUD, Copyright (C) 1993.
// CircleMUD is based on DikuMUD, Copyright (C) 1990, 1991.
// Original intermud_client.c (C) 1995, 96 by Chris Austin (Stryker@Tempus)
// Original lpc protocol (C) by Mark Lewis (Nostradamus@Zebedee)
//                           by J.W. Armstrong (Alvin@Sushi)
// ============================================================================

#ifndef __INTERMUD__NET_HH__
#define __INTERMUD__NET_HH__

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>

class _net {
private:
  int file_descriptor;
  string out_data;
  string in_data;
  unsigned long int ip_addr;
  unsigned short int ip_port;
  
public:
  void Init(int);
  string ReceiveData(struct sockaddr_in &);
  void FlushData();
  void AddToSet(fd_set &);
  bool CheckSet(fd_set &);
  void ClearSet(fd_set &);
  void CloseFD();
  string OutBuffer();
  int Desc();
  void SetAddr(unsigned long int);
  void SetPort(unsigned short int);
  _net& operator<<(string);
  _net& operator<<(int);
  _net& operator<<(unsigned int);
  _net& operator<<(short int);
  _net& operator<<(unsigned short int);
  _net& operator<<(long int);
  _net& operator<<(unsigned long int);
  _net& operator<<(_net& (*pf)(_net&));

  friend _net& sendit(_net&);

};

_net& sendit(_net&);

#endif
